from vcCommand import *
from vcHelpers.Application import *
app = getApplication()
selManager = app.SelectionManager

def diagIt():
  global diag, comp
  comps = selManager.getSelection(VC_SELECTION_COMPONENT)
  if comps:
    comp = comps[0]
    diag = getDialog('Change param name')


    old_prop = diag.addProperty('OldName',VC_STRING, None, VC_PROPERTY_STEP)
    old_prop.StepValues = [x.Name for x in comp.Properties]
    old_prop.Group = 10
    new_prop = diag.addProperty('NewName',VC_STRING)
    new_prop.Group = 20
    OK_prop = diag.addProperty('OK',VC_BUTTON, swapIt)
    OK_prop.Group = 30
    diag.show()

def swapIt(arg):
  global diag, comp
  ##
  ## test if the prop names are valid
  ##
  
  this = diag.getProperty('OldName').Value
  tothis = diag.getProperty('NewName').Value
  if not comp.getProperty(this):
    return
  if comp.getProperty(tothis):
    return
  ##
  ## del old, create new
  ##

  old = comp.getProperty(this)
  old_type = old.Type
  newprop = comp.createProperty(old_type, tothis)
  newprop.Value = old.Value
  newprop.ChangeOnRebuild = old.ChangeOnRebuild
  newprop.ChangeOnReconfigure = old.ChangeOnReconfigure
  newprop.ChangeOnUpdate = old.ChangeOnUpdate
  newprop.Group = old.Group
  newprop.IsVisible = old.IsVisible
  newprop.WritableWhenConnected = old.WritableWhenConnected
  newprop.WritableWhenDisconnected = old.WritableWhenDisconnected
  newprop.WritableWhenSimulating = old.WritableWhenSimulating
  comp.deleteProperty(old)
  ##
  ## scripts
  ##
  for py_script in comp.findBehavioursByType( VC_PYTHONSCRIPT ):
    py_script.Script = py_script.Script.replace( this, tothis )
  ##
  ## nodes
  ##
  nodes = [comp]
  features = []
  while nodes:
    node = nodes.pop(0)
    if node.Component == comp:
      nodes.extend( node.Children )
      features.append( node.RootFeature )
      if node.OffsetExpression.find(this) != -1:
        node.OffsetExpression = node.OffsetExpression.replace( this, tothis )
      if node.DOF and node.DOF.JointServoType == VC_JOINTTYPE_CUSTOM and node.JointExpression.find(this) != -1:
        node.JointExpression = node.JointExpression.replace( this, tothis )
      if node.DOF and node.DOF.Pivot.find(this) != -1:
        node.DOF.Pivot = node.DOF.Pivot.replace( this, tothis )
  ##
  ## features
  ##
  while features:
    fea = features.pop(0)
    features.extend( fea.Children )
    for feaprop in fea.Properties:
      if fea.Type == "Geometry" and feaprop.Name == "Uri": continue
      try: feaprop.Value = feaprop.Value.replace( this, tothis )
      except: pass
  ##
  ## expression props
  ##
  for compprop in comp.Properties:
    if compprop.Type == VC_EXPRESSION:
      try: compprop.Value = compprop.Value.replace( this, tothis )
      except: pass
  ##
  ## controller joint limits
  ##
  controllers = comp.findBehavioursByType( VC_SERVOCONTROLLER )
  controllers.extend( comp.findBehavioursByType( VC_ROBOTCONTROLLER ) )
  for controller in controllers:
    for j in controller.Joints:
      j.MinValue = j.MinValue.replace( this, tothis )
      j.MaxValue = j.MaxValue.replace( this, tothis )
  comp.rebuild()
  app.render()


addState( diagIt )